package cn.timer.api.bean.qyzx;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Table;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2019-11-11
*/

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder(toBuilder=true)
@Table(name="qyzx_suggestion_feeback")
@ApiModel("意见反馈表")
public class QyzxSuggestionFeeback extends Model<QyzxSuggestionFeeback> {

	private static final long serialVersionUID = 3545665863196016627L;

    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号",example="1")
    private Integer id;
    
	@ApiModelProperty(value="员工编号",example="9688")
    private Integer empNum;
	
	@ApiModelProperty(value="意见文本",example="不好用")
    private String opinionText;
	
	@ApiModelProperty(value="bug类型",example="1")
    private Integer bugType;
	
	@ApiModelProperty(value="创建时间",example="2020-4-20 08:00:00")
    private Date createTime;
    
	@ApiModelProperty(value="组织机构代码",example="117")
    private Integer orgCode;
	
	@ApiModelProperty(value="回复",example="那别用了")
    private String reply;
	
	@ApiModelProperty(value="回复时间",example="2020-4-21 08:00:00")
    private Date replyTime;
}