package cn.timer.api.controller.qyzx.service;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;

import cn.timer.api.bean.qyzx.QyzxOperLog;
import cn.timer.api.dto.qyzx.QyzxOperLogQuaryDto;

/**
 * 操作日志 服务层
 * 
 * @author ruoyi
 */
public interface QyzxOperLogService
{
    /**
     * 新增操作日志
     * 
     * @param operLog 操作日志对象
     */
    public void insertOperlog(QyzxOperLog operLog);

    /**
     * 查询系统操作日志集合
     * 
     * @param operLog 操作日志对象
     * @return 操作日志集合
     */
    public IPage<QyzxOperLog> selectPageByQuery(IPage<QyzxOperLog> page, QyzxOperLogQuaryDto operLog);

    /**
     * 批量删除系统操作日志
     * 
     * @param operIds 需要删除的操作日志ID
     * @return 结果
     */
    public int deleteOperLogByIds(List<QyzxOperLog> idList);

    /**
     * 查询操作日志详细
     * 
     * @param operId 操作ID
     * @return 操作日志对象
     */
    public QyzxOperLog selectOperLogById(Long operId);

    /**
     * 清空操作日志
     */
    public void cleanOperLog();
}
