package cn.timer.api.dto.kqmk;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class KqglAssoOvertimeRulesDto {


	@ApiModelProperty(value = "加班规则编号 加班规则编号", example = "1")
	private Integer id;

	@ApiModelProperty(value = "规则名称 ", example = "以审批时间计算加班")
	private String name;

	@ApiModelProperty(value = "应用范围", example = "（0：全公司  >0:考勤组id）")
	private Integer appliedScope;

	@ApiModelProperty(value = "工作日是否允许加班 0：否；1：是", example = "1")
	private Integer isWorkovertime;

	@ApiModelProperty(value = "计算方式 1：按审批时长计算", example = "1")
	private Integer workMode;

	@ApiModelProperty(value = "扣除休息时间开关 0：关；1：开", example = "0")
	private Integer workBuckleRest;

	@ApiModelProperty(value = "计为调休或加班费开关 0：关；1：开", example = "0")
	private Integer workSwitch;

	@ApiModelProperty(value = "1：按n计为调休 ", example = "1")
	private String workOne;

	@ApiModelProperty(value = "2：计为加班费 0：未选择；1：已选择", example = "0")
	private Integer workTwo;

	@ApiModelProperty(value = "3：多种选择 ", example = "1")
	private String workThree;

	@ApiModelProperty(value = "休息日是否允许加班 0：否；1：是", example = "0")
	private Integer isRestovertime;

	@ApiModelProperty(value = "计算方式 1：按审批时长计算", example = "1")
	private Integer restMode;

	@ApiModelProperty(value = "扣除休息时间开关 0：关；1：开", example = "0")
	private Integer restBuckleRest;

	@ApiModelProperty(value = "计为调休或加班费开关 0：关；1：开", example = "0")
	private Integer restSwitch;

	@ApiModelProperty(value = "1：按n计为调休 ", example = "1")
	private String restOne;

	@ApiModelProperty(value = "2：计为加班费 0：未选择；1：已选择", example = "0")
	private Integer restTwo;

	@ApiModelProperty(value = "3：多种选择 ", example = "1")
	private String restThree;

	@ApiModelProperty(value = "节假日是否允许加班 0：否；1：是", example = "0")
	private Integer isHolidays;

	@ApiModelProperty(value = "计算方式 ", example = "1")
	private Double holidaysMode;

	@ApiModelProperty(value = "扣除休息时间开关 0：关；1：开", example = "0")
	private Integer holidaysBuckleRest;

	@ApiModelProperty(value = "计为调休或加班费开关 0：关；1：开", example = "0")
	private Integer holidaysSwitch;

	@ApiModelProperty(value = "1：按n计为调休 ", example = "1")
	private String holidaysOne;

	@ApiModelProperty(value = "2：计为加班费 0：未选择；1：已选择", example = "0")
	private Integer holidaysTwo;

	@ApiModelProperty(value = "3：多种选择 ", example = "1")
	private String holidaysThree;

	@ApiModelProperty(value = "创建时间 ", example = "创建时间")
	private Long createTime;

	@ApiModelProperty(value = "创建人员 创建人员", example = "101")
	private Integer createUserid;

	@ApiModelProperty(value = "企业组织代码 企业组织代码", example = "117")
	private Integer orgCode;
	
	@ApiModelProperty(value = "扣除休息时间段", example = "12:00-13:30")
	private StartTimeRestDto[] starttime;
	
	@ApiModelProperty(value = "应用范围", example = "[]")
	private String[] applyrange;

}