package cn.timer.api.utils.router.business;

import cn.timer.api.utils.router.enums.ApproveEnum;

/**
 * 审批关联业务工厂类
 * @author Tang
 *
 */
public class SpmkAssoBusinessFactory {

	public static SpmkAssoBusiness createSpmkAssoType(ApproveEnum assotype) {
		SpmkAssoBusiness sat = null;
		switch (assotype) {
		case DEFAULT:
			break;
		case REGULARIZATION:
			sat = RegularizationBusiness.builder().build();
			break;
		case RESIGNATION:
			sat = ResignationBusiness.builder().build();
			break;
		case TRANSFER_POSITION:
			sat = TransferPositionBusiness.builder().build();
			break;
		case RECRUIT:
			sat = RecruitBusiness.builder().build();
			break;
		case WORK_OVERTIME:
			sat = WorkOvertimeBusiness.builder().build();
			break;
		case LEAVE:
			sat = LeaveBusiness.builder().build();
			break;
		case EVECTION:
			sat = EvectionBusiness.builder().build();
			break;
		case REISSUE_A_CARD:
			sat = ReissueACardBusiness.builder().build();
			break;
		default:
			break;
		}
		
		return sat;
		
	}
	
}
