package cn.timer.api.utils.router.business;

import org.springframework.beans.factory.annotation.Autowired;

import cn.hutool.json.JSONObject;
import cn.timer.api.controller.zzgl.service.ZzglBmgwMService;
import cn.timer.api.dto.spmk.FromData;
import cn.timer.api.dto.zzgl.UpEmpDeptDto;
import lombok.Builder;

/**
 * 调岗-业务
 * @author Tang
 *
 */
@Builder
public class TransferPositionBusiness extends SpmkAssoBusiness {

	@Autowired
	ZzglBmgwMService zzglBmgwMService;
	
	@Override
	public void handleApprove(JSONObject jsonObj) {
		// TODO Auto-generated method stub
		// 发起人企业id
		Integer orgCode = Integer.parseInt(jsonObj.get("orgCode",FromData.class).getValue());
		// 发起人id
		Integer id = Integer.parseInt(jsonObj.get("id",FromData.class).getValue());
		// 发起人名称
		String initiator = jsonObj.get("initiator",FromData.class).getValue();
		
		// 申请人
		String applicant = jsonObj.get("__applicant",FromData.class).getValue();
		// 申请原因
		String ReasonForApplication = jsonObj.get("__ReasonForApplication",FromData.class).getValue();
		// 调入部门
		Integer TransferInDepartment = Integer.parseInt(jsonObj.get("__TransferInDepartment",FromData.class).getValue());
		// 调入岗位
		String TransferInPosition = jsonObj.get("__TransferInPosition",FromData.class).getValue();
		// 生效日期
		String effectiveDate = jsonObj.get("__effectiveDate",FromData.class).getValue();
		// 备注
		String Remarks = jsonObj.get("Remarks",FromData.class).getValue();
		// 上传文件
		String UploadAttachment = jsonObj.get("UploadAttachment",FromData.class).getValue();
		
		UpEmpDeptDto upEmpDeptDto = UpEmpDeptDto.builder()
				.dpetId(TransferInDepartment)
				.isdg(1)
				.build();
		
		// 调 员工管理 业务
		zzglBmgwMService.applicationTransferPosition(id, orgCode, upEmpDeptDto);
	}

}
